----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:27:42 06/14/2011 
-- Design Name: 
-- Module Name:    Basys_Gnome - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_arith.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity SegCntrl is
	port (
		CLK1: IN STD_LOGIC;				            -- clock (naturally)
      Digit0: IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		Digit1: IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		Digit2: IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		Digit3: IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		reset: IN STD_LOGIC;
		seg: OUT STD_LOGIC_VECTOR (6 DOWNTO 0);	-- Segments
		an: OUT STD_LOGIC_VECTOR (3 DOWNTO 0);	   -- Digit
		dp: OUT STD_LOGIC				               -- dot in Segment
	);
end SegCntrl;

architecture Behavioral of SegCntrl is

          COMPONENT HEX2LEDA is
          port (
            HEX : in std_logic_vector (3 downto 0);    -- HEX input signal
            LEDN: out std_logic_vector (6 downto 0)    -- 7 segment output
          );                                        -- inverted
          end COMPONENT;
         
          SIGNAL         ck :  std_logic;
          SIGNAL      cntDiv: std_logic_vector(25 downto 0); -- general clock div/cnt
          
          SIGNAL  clock_div :  std_logic;
          signal h0,h1,h2,h3: std_logic_vector(6 downto 0); -- general clock div/cnt
          

begin
  ck <= CLK1;
  

  -- Generate divided clock for multiplexing LED
  ckDivider: process(ck,reset)
  begin
 
    if reset = '1' then
	    cntDiv <= "00000000000000000000000000";
	 elsif ck'event and ck='1' then
     
	   if (cntDiv < "11111111111111111111111111") then
		 cntDiv <= (unsigned(cntDiv) + 1);
	   else 
		 cntDiv <= (others => '0'); 
 	   end if;
	 end if;
  end process;
  
  

-- Decode Hex to LED 
    HL0: HEX2LEDA port map(
            HEX => Digit0,    -- HEX input signal
            LEDN => h0
          );                                        -- inverted
    HL1: HEX2LEDA port map(
            HEX => Digit1,    -- HEX input signal
            LEDN => h1
          );                                        -- inverted
    HL2: HEX2LEDA port map(
            HEX => Digit2,    -- HEX input signal
            LEDN => h2
          );                                        -- inverted
    HL3: HEX2LEDA port map(
            HEX => Digit3,    -- HEX input signal
            LEDN => h3
          );                                        -- inverted
          
-- Display  Digit0..3 on the 7 Segment Display
  LEDDisp: process(cntDiv(20), cntDiv(19), h0, h1, h2, h3)
   
    variable xan:std_logic_vector (1 downto 0);
  begin
     
    xan := cntDiv(11) & cntDiv(10);   
     -- Test:0,1  Implement:10,11
	  case xan is
	   when "00" => seg <= h0;  an <="1110"; dp <='1';
		when "01" => seg <= h1; an <="1101"; dp <='1';
		when "10" => seg <= h2; an <="1011"; dp <='1';
		when "11" => seg <= h3; an <="0111"; dp <='1';
		when others => seg <= "0000000"; an <="1111"; dp <='1';
	  end case;
  end process;
  

end Behavioral;

