--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:43:42 05/12/2017
-- Design Name:   
-- Module Name:   D:/work/Xilinx_Nexys/PipelineADC_Nexys/Test_Pipe.vhd
-- Project Name:  PipelineADC_Nexys
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: Pipe_NEXYS3
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY Test_Pipe IS
END Test_Pipe;
 
ARCHITECTURE behavior OF Test_Pipe IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT Pipe_NEXYS3
    PORT(
         CLK1 : IN  std_logic;
         CLK2 : IN  std_logic;
         btn : IN  std_logic_vector(3 downto 0);
         seg : OUT  std_logic_vector(6 downto 0);
         an : OUT  std_logic_vector(3 downto 0);
         dp : OUT  std_logic;
         led : OUT  std_logic_vector(7 downto 0);
         sw : IN  std_logic_vector(7 downto 0);
         JA : OUT  std_logic_vector(5 downto 0);
         DIN : IN  std_logic_vector(1 downto 0);
         JB : OUT  std_logic_vector(3 downto 0);
         TxD : OUT  std_logic;
         RxD : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal CLK1 : std_logic := '0';
   signal CLK2 : std_logic := '0';
   signal btn : std_logic_vector(3 downto 0) := (others => '0');
   signal sw : std_logic_vector(7 downto 0) := (others => '0');
   signal DIN : std_logic_vector(1 downto 0) := (others => '0');
   signal RxD : std_logic := '0';

 	--Outputs
   signal seg : std_logic_vector(6 downto 0);
   signal an : std_logic_vector(3 downto 0);
   signal dp : std_logic;
   signal led : std_logic_vector(7 downto 0);
   signal JA : std_logic_vector(5 downto 0);
   signal JB : std_logic_vector(3 downto 0);
   signal TxD : std_logic;

   -- Clock period definitions
   constant CLK1_period : time := 20 ns;
   constant CLK2_period : time := 20 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Pipe_NEXYS3 PORT MAP (
          CLK1 => CLK1,
          CLK2 => CLK2,
          btn => btn,
          seg => seg,
          an => an,
          dp => dp,
          led => led,
          sw => sw,
          JA => JA,
          DIN => DIN,
          JB => JB,
          TxD => TxD,
          RxD => RxD
        );

   -- Clock process definitions
   CLK1_process :process
   begin
		CLK1 <= '0';
		wait for CLK1_period/2;
		CLK1 <= '1';
		wait for CLK1_period/2;
   end process;
 
   CLK2_process :process
   begin
		CLK2 <= '0';
		wait for CLK2_period/2;
		CLK2 <= '1';
		wait for CLK2_period/2;
   end process;
   
	
   -- Stimulus process
   stim_proc: process
   begin		
	   btn <="0000";
      sw <="01000100"; -- 8 bit, dynamic operation, 1.25ms per sample 
      -- hold reset state for 100 ns.
 		wait for 100 ns;	
      btn(0) <='1';
		wait for 100 ns;	
		btn(0) <='0';
		

      wait for CLK1_period*10;

      -- insert stimulus here 
      DIN <="11";wait for 1000 ns;
      DIN <="00";wait for  500 ns;
      DIN <="11";wait for 1500 ns;
      DIN <="00";wait for 2000 ns;
      DIN <="11";wait for 1000 ns;
		
		-- observe countx, we, wr_uart, BCOde, TCode, tx_empty
		-- replace Countx(17) with countx(4) in Control RAM, UART
      -- simulate for xx time
      -- How often is there a valid for different switch position sw(3 downto 0)	
      -- "01000111" fast 1.25 ms per value, "01000100" default 11 ms one value
		-- 
 		
      wait;
   end process;

END;
